// JTHZ Jingle-machine, (c)Thyssen+Zimmerman, Immortalware JTHZ
// BC5-compilation, speed optimized profile

#include <windowsx.h>
#include "TZ_Jim.h"

HINSTANCE hInst;
static char szBuf[1024];
static char szTmpBuf[MAXPATH];
char bnames[12][10];	// names on buttons
HWND bt[12]; 			// button-windows
HWND hStatusWnd;		// status-window
int parts[3];			// status-window parts-array for SB_SETPARTS
HGLOBAL memS[12]; 	// wave-memory
LPVOID memSP[12]; 	// pointers to wave-memory
int memState[12]; 	// indicators of memory-usage
UINT playmode; 		// audio-playmode
int sync,loop;     	// global flags indicating sound-play-mode
int last,autostart; 	// last sound for spiffy autoplay-option!
int notify;				// create buttons with the BS_NOTIFY style
int rehearse;			// rehearse sounds on startup

// JTHZ alternative for damned (pre)Nashville file-requester:
#define NTFS_NEVERMIND 		0 	// no-flags state
#define NTFS_FILEMUSTEXIST	1 	// do not end Dialog with non-accessible file (Load only)
#define NTFS_FORCEEXT 		2 	// activate lpstrDefExt (Save-related)
#define NTFS_EMPTYFILE		4	// allow return of empty filename (OK-button only dus!)
struct NTFS{
// 'everything' must be filled on input!!!
	int 	Flags; 							// NTFS_...
	char 	lpstrTitle[50];            // Win-title
	char 	lpstrFilter[4]; 				// _single_ extension-filter
	char 	lpstrDefExt[4];				// fill if NTFS_FORCEEXT (zonder dot!)
	char 	lpstrPath[MAXPATH]; 			// input/output-path
	char 	lpstrFile[MAXFILE+MAXEXT]; // edited or chosen file, fill on input too! ""
}ofn32; // this is only experimental stuff!! full implementation coming sooN!


#pragma argsused
#pragma warn -aus
LRESULT CALLBACK NTFSDlgProc(HWND hWnd,UINT wMsg,WPARAM wParam,LPARAM lParam){
	char szBuf[260];
	char szName[MAXFILE];
	int ret,i;
	struct ffblk ff;
	long selected;
	static int comboprev;

	switch(wMsg){
		case WM_INITDIALOG:
			if(chdir(ofn32.lpstrPath)){
				// default to current dir:
				getcwd(ofn32.lpstrPath,sizeof(ofn32.lpstrPath));
				if(strlen(ofn32.lpstrPath)>3)
					strcat(ofn32.lpstrPath,"\\");
			}
			// drives:
			strcpy(szBuf,ofn32.lpstrPath);
			DlgDirListComboBox(hWnd,szBuf,IDC_CBDRIVES,0,DDL_EXCLUSIVE|DDL_DRIVES);
			sprintf(szBuf,"[-%c-]",ofn32.lpstrPath[0]);
			ret=(int)SendDlgItemMessage(hWnd,IDC_CBDRIVES,CB_FINDSTRING,
															0,(LPARAM)(LPCSTR)szBuf);
			SendDlgItemMessage(hWnd,IDC_CBDRIVES,CB_SETCURSEL,(WPARAM)ret,0);
			comboprev=ret; // prevent rootback when COMBO-CHANGE!
								// (IDC_COMBO-msg repeats, sorry for spaghetti)
			// dirs:
			sprintf(szBuf,"%s\\*.*",ofn32.lpstrPath);
			if(!findfirst(szBuf,&ff,0x17)){
				if((ff.ff_attrib&FA_DIREC)&&strcmp(".",ff.ff_name))
					SendDlgItemMessage(hWnd,IDC_LBFOLDERS,LB_ADDSTRING,0,(LPARAM)((LPSTR)ff.ff_name));
				while(!findnext(&ff)){
					if((ff.ff_attrib&FA_DIREC)&&strcmp(".",ff.ff_name))
						SendDlgItemMessage(hWnd,IDC_LBFOLDERS,LB_ADDSTRING,0,(LPARAM)((LPSTR)ff.ff_name));
				}
			}
			// set Window-title:
			SendMessage(hWnd,WM_SETTEXT,0,(LPARAM)((LPCSTR)ofn32.lpstrTitle));
			// display path:
			strcpy(szBuf,ofn32.lpstrPath);
			if(strlen(szBuf)==2)
				strcat(szBuf,"\\");
			SetDlgItemText(hWnd,IDC_FOLDER,szBuf);
			// files:
			sprintf(szBuf,"%s\\*.%s",ofn32.lpstrPath,ofn32.lpstrFilter);
			if(!findfirst(szBuf,&ff,0x07)){
				if(!(ff.ff_attrib&FA_DIREC))
					SendDlgItemMessage(hWnd,IDC_LBFILES,LB_ADDSTRING,0,(LPARAM)((LPSTR)ff.ff_name));
				while(!findnext(&ff))
					if(!(ff.ff_attrib&FA_DIREC))
						SendDlgItemMessage(hWnd,IDC_LBFILES,LB_ADDSTRING,0,(LPARAM)((LPSTR)ff.ff_name));
			}
			// display+select inputfile:
			SetDlgItemText(hWnd,IDC_EDITFILE,ofn32.lpstrFile);
			SendDlgItemMessage(hWnd,IDC_EDITFILE,EM_SETSEL,(WPARAM)(INT)0,(LPARAM)(INT)-1);
			return TRUE;
		case WM_COMMAND:
			switch(GET_WM_COMMAND_ID(wParam,lParam)){
				case IDC_CBDRIVES:
					ret=(int)SendDlgItemMessage(hWnd,IDC_CBDRIVES,CB_GETCURSEL,0,0);
					if(ret==comboprev)
						break; // we'll wait!
					comboprev=ret;
					SendDlgItemMessage(hWnd,IDC_CBDRIVES,CB_GETLBTEXT,(WPARAM)ret,
																		(LPARAM)(LPCSTR)szBuf);
					sprintf(ofn32.lpstrPath,"%c:",szBuf[2]);
					// dirs:
					SendDlgItemMessage(hWnd,IDC_LBFOLDERS,LB_RESETCONTENT,0,0);
					sprintf(szBuf,"%s\\*.*",ofn32.lpstrPath);
					if(!findfirst(szBuf,&ff,0x17)){
						if((ff.ff_attrib&FA_DIREC)&&strcmp(".",ff.ff_name))
							SendDlgItemMessage(hWnd,IDC_LBFOLDERS,LB_ADDSTRING,0,(LPARAM)((LPSTR)ff.ff_name));
						while(!findnext(&ff)){
							if((ff.ff_attrib&FA_DIREC)&&strcmp(".",ff.ff_name))
								SendDlgItemMessage(hWnd,IDC_LBFOLDERS,LB_ADDSTRING,0,
																(LPARAM)((LPSTR)ff.ff_name));
						}
					}
					strcpy(szBuf,ofn32.lpstrPath);
					if(strlen(szBuf)==2)
						strcat(szBuf,"\\");
					SetDlgItemText(hWnd,IDC_FOLDER,szBuf);
					// files:
					sprintf(szBuf,"%s\\*.%s",ofn32.lpstrPath,ofn32.lpstrFilter);
					SendDlgItemMessage(hWnd,IDC_LBFILES,LB_RESETCONTENT,0,0);
					if(!findfirst(szBuf,&ff,0x07)){
						if(!(ff.ff_attrib&FA_DIREC))
							SendDlgItemMessage(hWnd,IDC_LBFILES,LB_ADDSTRING,0,(LPARAM)((LPSTR)ff.ff_name));
						while(!findnext(&ff))
							if(!(ff.ff_attrib&FA_DIREC))
								SendDlgItemMessage(hWnd,IDC_LBFILES,LB_ADDSTRING,0,(LPARAM)((LPSTR)ff.ff_name));
					}
					break;
				case IDC_LBFILES:
					switch(GET_WM_COMMAND_CMD(wParam,lParam)){
						case LBN_DBLCLK:
							szBuf[0]=0; // see EM_GETLINE in your WinAPI-bible/helpfile
							szBuf[1]=250;
							ret=(int)SendDlgItemMessage(hWnd,IDC_EDITFILE,EM_GETLINE,(WPARAM)0,
																					(LPARAM)(LPCSTR)szBuf);
							szBuf[ret]=0;
							strcpy(ofn32.lpstrFile,szBuf);
							// DefExt
							if(ofn32.Flags&NTFS_FORCEEXT){
								fnsplit(ofn32.lpstrFile,NULL,NULL,szName,NULL);
								sprintf(ofn32.lpstrFile,"%s.%s",szName,ofn32.lpstrDefExt);
							}
							EndDialog(hWnd,TRUE);
							return(TRUE);
						case LBN_SELCHANGE:
							selected=SendDlgItemMessage(hWnd,IDC_LBFILES,LB_GETCURSEL,0,0);
							SendDlgItemMessage(hWnd,IDC_LBFILES,LB_GETTEXT,(WPARAM)selected,
																				(LPARAM)((LPSTR)szBuf));
							SetDlgItemText(hWnd,IDC_EDITFILE,szBuf);
							SendDlgItemMessage(hWnd,IDC_EDITFILE,EM_SETSEL,(WPARAM)(INT)0,(LPARAM)(INT)-1);
							break;
					}
					break;
				case IDC_LBFOLDERS:
					switch(GET_WM_COMMAND_CMD(wParam,lParam)){
						case LBN_DBLCLK:
							ret=(int)SendDlgItemMessage(hWnd,IDC_LBFOLDERS,LB_GETCURSEL,0,0);
							SendDlgItemMessage(hWnd,IDC_LBFOLDERS,LB_GETTEXT,(WPARAM)ret,
																			(LPARAM)((LPSTR)szBuf));
							if(szBuf[0]=='.'){ // parent-dir
								for(i=strlen(ofn32.lpstrPath)-2;i>0;i--){
									if(ofn32.lpstrPath[i]=='\\'){
										ofn32.lpstrPath[i]=0;
										break;
									}
								}
							}
							else{ // dir
								strcat(ofn32.lpstrPath,"\\");
								strcat(ofn32.lpstrPath,szBuf);
							}
							// empty the box!
							SendDlgItemMessage(hWnd,IDC_LBFOLDERS,LB_RESETCONTENT,0,0);
							// rescan dirs:
							sprintf(szBuf,"%s\\*.*",ofn32.lpstrPath);
							if(!findfirst(szBuf,&ff,0x17)){
								if((ff.ff_attrib&FA_DIREC)&&strcmp(".",ff.ff_name))
									SendDlgItemMessage(hWnd,IDC_LBFOLDERS,LB_ADDSTRING,0,
																	(LPARAM)((LPSTR)ff.ff_name));
								while(!findnext(&ff)){
									if((ff.ff_attrib&FA_DIREC)&&strcmp(".",ff.ff_name))
										SendDlgItemMessage(hWnd,IDC_LBFOLDERS,LB_ADDSTRING,0,
																		(LPARAM)((LPSTR)ff.ff_name));
								}
							}
							strcpy(szBuf,ofn32.lpstrPath);
							if(strlen(szBuf)==2)
								strcat(szBuf,"\\");
							SetDlgItemText(hWnd,IDC_FOLDER,szBuf);
							// rescan files:
							sprintf(szBuf,"%s\\*.%s",ofn32.lpstrPath,ofn32.lpstrFilter);
							SendDlgItemMessage(hWnd,IDC_LBFILES,LB_RESETCONTENT,0,0);
							if(!findfirst(szBuf,&ff,0x07)){
								if(!(ff.ff_attrib&FA_DIREC))
									SendDlgItemMessage(hWnd,IDC_LBFILES,LB_ADDSTRING,0,
																	(LPARAM)((LPSTR)ff.ff_name));
								while(!findnext(&ff))
									if(!(ff.ff_attrib&FA_DIREC))
										SendDlgItemMessage(hWnd,IDC_LBFILES,LB_ADDSTRING,0,
																	(LPARAM)((LPSTR)ff.ff_name));
							}
							break;
					}
					break;
				case IDC_OKAY:
					szBuf[0]=0; // erhem...
					szBuf[1]=250;
					ret=(int)SendDlgItemMessage(hWnd,IDC_EDITFILE,EM_GETLINE,(WPARAM)0,
																			(LPARAM)(LPCSTR)szBuf);
					szBuf[ret]=0;
					strcpy(ofn32.lpstrFile,szBuf);
					if(strlen(ofn32.lpstrFile)==0){
						if(ofn32.Flags&NTFS_EMPTYFILE){
							EndDialog(hWnd,TRUE);
							return(TRUE);
						}
						else
                  	break;
					}
					if(ofn32.Flags&NTFS_FILEMUSTEXIST){
						sprintf(szBuf,"%s\\%s",ofn32.lpstrPath,ofn32.lpstrFile);
						if(access(szBuf,0)){
							sprintf(szBuf,"%s\nThis file can't be found.\nMake sure that you specify a correct path and filename.",
									ofn32.lpstrFile);
							MessageBox(hWnd,szBuf,"Error",MB_OK|MB_ICONEXCLAMATION);
							break; //!!! end case
						}
					}
					// DefExt
					if(ofn32.Flags&NTFS_FORCEEXT){
						fnsplit(ofn32.lpstrFile,NULL,NULL,szName,NULL);
						sprintf(ofn32.lpstrFile,"%s.%s",szName,ofn32.lpstrDefExt);
					}
					EndDialog(hWnd,TRUE);
					return(TRUE);
				case IDC_NOWAY:
				case IDCANCEL:
					// report cancel:
					EndDialog(hWnd,FALSE);
					return(FALSE);
			}
	}
	return(FALSE);
}


BOOL InitApplication(HINSTANCE hInstance){
	HCURSOR hcurSave;
	WNDCLASSEX wc;
	int okay=1,i;
	char szSmallBuf[7];
	char filename[MAXFILE];
	FILE *fp;
	long l;

	// fast check existence of WAVE-files:
	for(i=0;(i<12)&&okay;i++){
		sprintf(szSmallBuf,"Wave%d",i+1);
      // rot op met je registry:
		GetPrivateProfileString(INIC,szSmallBuf,"",szBuf,sizeof(szBuf),"IMMORTAL.INI");
		if(strlen(szBuf)){
			if(access(szBuf,0)){
				strupr(szBuf);
				strcat(szBuf,":\nThis file is missing!\nChoose OK to assign < empty > to button ");
				sprintf(szTmpBuf,"%d",i+1);
				strcat(szBuf,szTmpBuf);
				strcat(szBuf,"\nChoose Cancel to stop TZ_Jim from loading");
				if(MessageBox(NULL,szBuf,"WARNING",MB_OKCANCEL|MB_ICONSTOP)==IDCANCEL)
					okay=0;
				else
					WritePrivateProfileString(INIC,szSmallBuf,"","IMMORTAL.INI");
			}
		}
	}
	if(!okay)
		return FALSE;

	hcurSave=SetCursor(LoadCursor(NULL,IDC_WAIT));
	// all listed wavs in IMMORTAL.INI can be accessed
	for(i=0;i<12;i++){
		sprintf(szSmallBuf,"Wave%d",i+1);
		GetPrivateProfileString(INIC,szSmallBuf,"",szBuf,sizeof(szBuf),"IMMORTAL.INI");
		if(strlen(szBuf)){
			fp=fopen(szBuf,"rb");
			l=filelength(fileno(fp));
			memS[i]=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE,(DWORD)l);
			if(memS[i]==NULL){
				MessageBox(NULL,"Not enough memory available!","ERROR",MB_OK|MB_ICONSTOP);
				break; // for
			}
			memSP[i]=GlobalLock(memS[i]);
			fread(memSP[i],l,1,fp);
			fclose(fp);
			fnsplit(szBuf,NULL,NULL,filename,NULL);
			filename[8]=0; // chop off if NTFS-name
			strlwr(filename);
			filename[0]=(char)toupper(filename[0]);
			strcpy(bnames[i],filename);
			memState[i]=1;
		}
		else{
			strcpy(bnames[i],"< empty >");
			memState[i]=0;
		}
	}

	SetCursor(hcurSave); // restore cursor

	wc.style=CS_HREDRAW|CS_VREDRAW;
	wc.lpfnWndProc=(WNDPROC)MainWndProc;
	wc.cbClsExtra=0;
	wc.cbWndExtra=0;
   wc.cbSize=sizeof(WNDCLASSEX);
	wc.hInstance=hInstance;
	wc.hIcon=LoadIcon(hInstance,"ICON_1");
	wc.hIconSm=LoadIcon(hInstance,"ICON_2");
	wc.hCursor=LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground=GetStockObject(BLACK_BRUSH);
	wc.lpszMenuName=0;
	wc.lpszClassName="TZJIM";
	return(RegisterClassEx(&wc));
}


BOOL InitInstance(HINSTANCE hInstance,int nCmdShow){
	HWND hWnd;
	HMENU hmenu;
	int i,locked,x,y,w,h; // windowstyle

	hInst=hInstance;

	// locking of mainwindow:
	locked=GetPrivateProfileInt(INIC,"Lock",1234,"IMMORTAL.INI");
	if(locked==1234){ // no entry yet
		WritePrivateProfileString(INIC,"Lock","0","IMMORTAL.INI");
		locked=0;
	}
	// sync or async audio:
	sync=GetPrivateProfileInt(INIC,"Sync",1234,"IMMORTAL.INI");
	if(sync==1234){ // no entry yet
		WritePrivateProfileString(INIC,"Sync","0","IMMORTAL.INI");
		sync=0;
	}
	// looped audio:
	loop=GetPrivateProfileInt(INIC,"Loop",1234,"IMMORTAL.INI");
	if(loop==1234){ // no entry yet
		WritePrivateProfileString(INIC,"Sync","0","IMMORTAL.INI");
		loop=0;
	}
	if(loop&&sync){
		sync=0;
		WritePrivateProfileString(INIC,"Sync","0","IMMORTAL.INI");
	}
	// autoplay:
	autostart=GetPrivateProfileInt(INIC,"Auto",1234,"IMMORTAL.INI");
	if(autostart==1234){
		WritePrivateProfileString(INIC,"Auto","1","IMMORTAL.INI");
		autostart=1; // default on, JBT request
	}
	playmode=SND_MEMORY;
   playmode+=sync?SND_SYNC:SND_ASYNC;
	if(loop)
		playmode+=SND_LOOP;
	notify=GetPrivateProfileInt(INIC,"Notify",1234,"IMMORTAL.INI");
   if(notify==1234){
		WritePrivateProfileString(INIC,"Notify","0","IMMORTAL.INI");
		notify=0; // default off
   }
	rehearse=GetPrivateProfileInt(INIC,"Rehearse",1234,"IMMORTAL.INI");
   if(rehearse==1234){
		WritePrivateProfileString(INIC,"Rehearse","1","IMMORTAL.INI");
		rehearse=1; // default on
   }
	x=GetPrivateProfileInt(INIC,"X",-1,"IMMORTAL.INI");
	y=GetPrivateProfileInt(INIC,"Y",-1,"IMMORTAL.INI");
	w=GetPrivateProfileInt(INIC,"W",-1,"IMMORTAL.INI");
	h=GetPrivateProfileInt(INIC,"H",-1,"IMMORTAL.INI");

	hWnd=CreateWindow(
		"TZJIM",
		"TZ Jingle Machine",
		locked?WS_SYSMENU|WS_MINIMIZEBOX:WS_OVERLAPPEDWINDOW,
		x<0?CW_USEDEFAULT:x,
		y<0?CW_USEDEFAULT:y,
		w<0?CW_USEDEFAULT:w,
		h<0?CW_USEDEFAULT:h,
		NULL,
		NULL,
		hInstance,
		NULL
	);
	if(!hWnd)
		return(FALSE);

	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);

   InitCommonControls();

	hmenu=GetSystemMenu(hWnd,FALSE);

	AppendMenu(hmenu,MF_SEPARATOR,0,(LPSTR)NULL);

	AppendMenu(hmenu,MF_STRING,IDM_LOAD,"Load TZ-file");
	AppendMenu(hmenu,MF_SEPARATOR,0,(LPSTR)NULL);

	AppendMenu(hmenu,MF_STRING,IDM_LOOP,"Loop in memory");
	CheckMenuItem(hmenu,IDM_LOOP,loop?MF_CHECKED:MF_UNCHECKED);

	AppendMenu(hmenu,MF_STRING,IDM_SYNC,"Sync audio");
	CheckMenuItem(hmenu,IDM_SYNC,sync?MF_CHECKED:MF_UNCHECKED);

	AppendMenu(hmenu,MF_STRING,IDM_AUTO,"Startup autoplay");
	CheckMenuItem(hmenu,IDM_AUTO,autostart?MF_CHECKED:MF_UNCHECKED);

	AppendMenu(hmenu,MF_STRING,IDM_NOTIFY,"BS_NOTIFY");
	CheckMenuItem(hmenu,IDM_NOTIFY,notify?MF_CHECKED:MF_UNCHECKED);

	AppendMenu(hmenu,MF_STRING,IDM_REHEARSE,"Rehearse");
	CheckMenuItem(hmenu,IDM_REHEARSE,rehearse?MF_CHECKED:MF_UNCHECKED);

	AppendMenu(hmenu,MF_SEPARATOR,0,(LPSTR)NULL);

	AppendMenu(hmenu,MF_STRING,IDM_LOCKED,"Freeez window");
	CheckMenuItem(hmenu,IDM_LOCKED,locked?MF_CHECKED:MF_UNCHECKED);

	AppendMenu(hmenu,MF_STRING,IDM_HELP,"Help!");
	AppendMenu(hmenu,MF_STRING,IDM_ABOUT,"About TZ-jim");

   if(rehearse){
		playmode=SND_MEMORY|SND_ASYNC;
		for(i=0;i<12;i++)
			sndPlaySound(memSP[i],playmode);
		sndPlaySound(NULL,0);
   }

	if(autostart){
		last=GetPrivateProfileInt(INIC,"Last",0,"IMMORTAL.INI");
		sndPlaySound(memSP[last],playmode);
	}

	return (TRUE);
}


LRESULT CALLBACK MainWndProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam){
	HMENU hmenu;
	WINDOWPLACEMENT wp;
	RECT rect,srect;
   SIZE size1,size2;
   HDC hdc;
	int i,x,y,width,height,ret,locked;
	char szSmallBuf[7];
	FILE *fp,*fp2;
	long l;
	char filename[MAXFILE];

	switch(message){
		case WM_COMMAND:
			switch(GET_WM_COMMAND_ID(wParam,lParam)){
				case WM_USER:
					sndPlaySound(memSP[0],playmode);
					last=0;
					break;
				case WM_USER+1:
					sndPlaySound(memSP[1],playmode);
					last=1;
					break;
				case WM_USER+2:
					sndPlaySound(memSP[2],playmode);
					last=2;
					break;
				case WM_USER+3:
					sndPlaySound(memSP[3],playmode);
					last=3;
					break;
				case WM_USER+4:
					sndPlaySound(memSP[4],playmode);
					last=4;
					break;
				case WM_USER+5:
					sndPlaySound(memSP[5],playmode);
					last=5;
					break;
				case WM_USER+6:
					sndPlaySound(memSP[6],playmode);
					last=6;
					break;
				case WM_USER+7:
					sndPlaySound(memSP[7],playmode);
					last=7;
					break;
				case WM_USER+8:
					sndPlaySound(memSP[8],playmode);
					last=8;
					break;
				case WM_USER+9:
					sndPlaySound(memSP[9],playmode);
					last=9;
					break;
				case WM_USER+10:
					sndPlaySound(memSP[10],playmode);
					last=10;
					break;
				case WM_USER+11:
					sndPlaySound(memSP[11],playmode);
					last=11;
					break;
			}
			SetFocus(hWnd); // you'll lose keyboard after mouseclick if ya don't!!
			break;
		case WM_SYSCOMMAND:
			switch(wParam){
				case IDM_LOAD:
            	sndPlaySound(NULL,playmode);
					GetPrivateProfileString("TZ_Wav","Savefile","",szTmpBuf,
												sizeof(szTmpBuf),"IMMORTAL.INI");
					if(!strlen(szTmpBuf)){
						// default to current dir:
						getcwd(szTmpBuf,sizeof(szTmpBuf));
						if(strlen(szTmpBuf)>3)
							strcat(szTmpBuf,"\\");
						strcat(szTmpBuf,"*.TZ");
					}
					fnsplit(szTmpBuf,ofn32.lpstrPath,szBuf,ofn32.lpstrFile,&szBuf[300]);
					strcat(ofn32.lpstrPath,szBuf);
					ofn32.lpstrPath[strlen(ofn32.lpstrPath)-1]=0; // remove ending slash
					strcat(ofn32.lpstrFile,&szBuf[300]);
					ofn32.Flags=NTFS_FILEMUSTEXIST;
					sprintf(ofn32.lpstrTitle,"Pick TZ-file to load..");
					strcpy(ofn32.lpstrDefExt,"TZ");
					strcpy(ofn32.lpstrFilter,"TZ");
					if(DialogBox(hInst,(LPCTSTR)"NTFS",hWnd,(DLGPROC)NTFSDlgProc)==TRUE){
						UpdateWindow(hWnd);
						sprintf(szBuf,"%s\\%s",ofn32.lpstrPath,ofn32.lpstrFile);
						fp=fopen(szBuf,"r");
						fread(szBuf,6,1,fp);
						szBuf[5]=0;
						strrev(szBuf);
						if(!strcmp(szBuf,HEADER)){
							for(i=0;i<12;i++){
								ret=fscanf(fp,"%[^\n]%*c",szBuf);
								if(ret==0||feof(fp))
									break;
								if(!access(szBuf,0)){
									// unload memory:
									if(memState[i]){
										GlobalUnlock(memS[i]);
										GlobalFree(memS[i]);
									}
									// reload new file (file is there, NTFS_FILEMUSTEXIST):
									fp2=fopen(szBuf,"rb");
									l=filelength(fileno(fp2));
									memS[i]=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE,(DWORD)l);
									if(memS[i]==NULL){
										MessageBox(NULL,"Not enough memory available!","ERROR",MB_OK|MB_ICONSTOP);
										fclose(fp2);
										break;
									}
									memSP[i]=GlobalLock(memS[i]);
									fread(memSP[i],l,1,fp2);
									fclose(fp2);
									// update ini:
									sprintf(szSmallBuf,"Wave%d",i+1);
									WritePrivateProfileString(INIC,szSmallBuf,szBuf,"IMMORTAL.INI");
									fnsplit(szBuf,NULL,NULL,filename,NULL);
									filename[8]=0; // chop off if NTFS-name
									strlwr(filename);
									filename[0]=(char)toupper(filename[0]);
									strcpy(bnames[i],filename);
									memState[i]=1;
									// update button-name:
            				 	sprintf(szTmpBuf,"F%d",i+1);
				               hdc=GetDC(hStatusWnd);
				               sprintf(szBuf,"");
									for(;;){
										GetTextExtentPoint32(hdc,szTmpBuf,strlen(szTmpBuf),&size1);
										GetTextExtentPoint32(hdc,bnames[i],strlen(bnames[i]),&size2);
				                  if(size1.cx>=size2.cx)
				                  	break;
				                  // add space to both sides of Fn:
				                  szBuf[strlen(szBuf)+1]=0;
				                  szBuf[strlen(szBuf)]=' ';
				                  sprintf(szTmpBuf,"%sF%d%s",szBuf,i+1,szBuf);
									}
				               ReleaseDC(hStatusWnd,hdc);
									sprintf(szBuf,"%s\n%s",szTmpBuf,bnames[i]);
									SendMessage(bt[i],WM_SETTEXT,0,(LPARAM)((LPCSTR)szBuf));
								}
								else{
									strupr(szBuf);
									strcat(szBuf,"\n\nCan't load that file!");
									MessageBox(hWnd,szBuf,"ERROR",MB_OK);
								}
							}
						}
						else{
							sprintf(szBuf,"%s\n\nWrong file format!",ofn32.lpstrFile);
							MessageBox(hWnd,szBuf,"ERROR",MB_OK);
						}
						fclose(fp);
					}
					break;
				case IDM_ABOUT:
					LoadString(hInst,IDS_STRING1,szBuf,sizeof(szBuf));
					if(MessageBox(hWnd,szBuf,"TZ Jingle Machine",MB_YESNO)==IDNO)
						ExitWindowsEx(EWX_SHUTDOWN,0);
					break;
				case IDM_HELP:
					WinHelp(hWnd,HELPFILE,HELP_KEY,(unsigned long)(LPSTR)"TZ-Jim");
					break;
				case IDM_LOCKED:
					hmenu=GetSystemMenu(hWnd,FALSE);
					locked=GetPrivateProfileInt(INIC,"Lock",0,"IMMORTAL.INI");
					if(--locked<0)
						locked=1;
					CheckMenuItem(hmenu,IDM_LOCKED,locked?MF_CHECKED:MF_UNCHECKED);
					sprintf(szBuf,"%d",locked);
					WritePrivateProfileString(INIC,"Lock",szBuf,"IMMORTAL.INI");
					if(locked)
						strcpy(szBuf,"Window will be locked\nnext time you start this program");
					else
						strcpy(szBuf,"Window will be unlocked\nnext time you start this program");
					MessageBox(hWnd,szBuf,"NOTE:",MB_OK|MB_ICONINFORMATION);
					break;
            case IDM_NOTIFY:
            	hmenu=GetSystemMenu(hWnd,FALSE);
               notify=GetPrivateProfileInt(INIC,"Notify",0,"IMMORTAL.INI");
               if(--notify<0)
               	notify=1;
					CheckMenuItem(hmenu,IDM_NOTIFY,notify?MF_CHECKED:MF_UNCHECKED);
					sprintf(szBuf,"%d",notify);
					WritePrivateProfileString(INIC,"Notify",szBuf,"IMMORTAL.INI");
               SendMessage(hWnd,WM_SIZE,SIZE_RESTORED,0);
            	break;
            case IDM_REHEARSE:
            	hmenu=GetSystemMenu(hWnd,FALSE);
               rehearse=GetPrivateProfileInt(INIC,"Rehearse",0,"IMMORTAL.INI");
               if(--rehearse<0)
               	rehearse=1;
					CheckMenuItem(hmenu,IDM_REHEARSE,rehearse?MF_CHECKED:MF_UNCHECKED);
					sprintf(szBuf,"%d",rehearse);
					WritePrivateProfileString(INIC,"Rehearse",szBuf,"IMMORTAL.INI");
            	break;
				case IDM_SYNC:
					hmenu=GetSystemMenu(hWnd,FALSE);
					if(--sync<0)
						sync=1;
					if(sync&&loop){
						LoadString(hInst,IDS_STRING2,szBuf,sizeof(szBuf));
						if(MessageBox(hWnd,szBuf,"Warning",MB_OKCANCEL)==IDCANCEL){
							sync=0;
							break;
						}
						else{
							loop=0;
							sprintf(szBuf,"%d",0);
							WritePrivateProfileString(INIC,"Loop",szBuf,"IMMORTAL.INI");
							CheckMenuItem(hmenu,IDM_LOOP,MF_UNCHECKED);
						}
					}
					CheckMenuItem(hmenu,IDM_SYNC,sync?MF_CHECKED:MF_UNCHECKED);
					sprintf(szBuf,"%d",sync);
					WritePrivateProfileString(INIC,"Sync",szBuf,"IMMORTAL.INI");
					playmode=SND_MEMORY;
					if(sync)
						playmode+=SND_SYNC;
					else
						playmode+=SND_ASYNC;
					if(loop)
						playmode+=SND_LOOP;
					else
						sndPlaySound(NULL,playmode);
	            SendMessage(hStatusWnd,SB_SETTEXT,(WPARAM)1,
            					loop?(LPARAM)"LOOP: ON":(LPARAM)"LOOP:OFF");
   	         SendMessage(hStatusWnd,SB_SETTEXT,(WPARAM)2,
            					sync?(LPARAM)"SYNC: ON":(LPARAM)"SYNC:OFF");
					break;
				case IDM_LOOP:
					hmenu=GetSystemMenu(hWnd,FALSE);
					if(--loop<0)
						loop=1;
					if(sync&&loop){
						LoadString(hInst,IDS_STRING3,szBuf,sizeof(szBuf));
						if(MessageBox(hWnd,szBuf,"Warning",MB_OKCANCEL)==IDCANCEL){
							loop=0;
							break;
						}
						else{
							sync=0;
							sprintf(szBuf,"%d",0);
							WritePrivateProfileString(INIC,"Sync",szBuf,"IMMORTAL.INI");
							CheckMenuItem(hmenu,IDM_SYNC,MF_UNCHECKED);
						}
					}
					CheckMenuItem(hmenu,IDM_LOOP,loop?MF_CHECKED:MF_UNCHECKED);
					sprintf(szBuf,"%d",loop);
					WritePrivateProfileString(INIC,"Loop",szBuf,"IMMORTAL.INI");
					playmode=SND_MEMORY;
               playmode+=sync?SND_SYNC:SND_ASYNC;
					if(loop)
						playmode+=SND_LOOP;
					else
						sndPlaySound(NULL,playmode);
	            SendMessage(hStatusWnd,SB_SETTEXT,(WPARAM)1,
            					loop?(LPARAM)"LOOP: ON":(LPARAM)"LOOP:OFF");
   	         SendMessage(hStatusWnd,SB_SETTEXT,(WPARAM)2,
            					sync?(LPARAM)"SYNC: ON":(LPARAM)"SYNC:OFF");
					break;
				case IDM_AUTO:
					hmenu=GetSystemMenu(hWnd,FALSE);
					autostart=GetPrivateProfileInt(INIC,"Auto",0,"IMMORTAL.INI");
					if(--autostart<0)
						autostart=1;
					CheckMenuItem(hmenu,IDM_AUTO,autostart?MF_CHECKED:MF_UNCHECKED);
					sprintf(szBuf,"%d",autostart);
					WritePrivateProfileString(INIC,"Auto",szBuf,"IMMORTAL.INI");
					sprintf(szBuf,"Startup autoplay %sabled",autostart?"en":"dis");
					MessageBox(hWnd,szBuf,"NOTE:",MB_OK|MB_ICONINFORMATION);
					break;
				default:
					return(DefWindowProc(hWnd,message,wParam,lParam));
			}
			return 0;
		case WM_SYSKEYDOWN: // F10!!! und las auch sum uther syskeezz
			sndPlaySound(memSP[9],playmode);
			last=9;
			return 0;
		case WM_PARENTNOTIFY: // rite button processing
			if(LOWORD(wParam)==WM_RBUTTONDOWN){
				GetClientRect(hWnd,&rect);
				i=HIWORD(lParam)/(rect.bottom/3)*4+LOWORD(lParam)/(rect.right/4);
				sprintf(szSmallBuf,"Wave%d",i+1);
				GetPrivateProfileString(INIC,szSmallBuf,"",szTmpBuf,
										sizeof(szTmpBuf),"IMMORTAL.INI");
				if(!strlen(szTmpBuf)){
					// default to current dir:
					getcwd(szTmpBuf,sizeof(szTmpBuf));
					if(strlen(szTmpBuf)>3)
						strcat(szTmpBuf,"\\");
					strcat(szTmpBuf,"*.WAV");
				}
				fnsplit(szTmpBuf,ofn32.lpstrPath,szBuf,ofn32.lpstrFile,&szBuf[300]);
				strcat(ofn32.lpstrPath,szBuf);
				ofn32.lpstrPath[strlen(ofn32.lpstrPath)-1]=0; // remove ending slash
				strcat(ofn32.lpstrFile,&szBuf[300]);
				ofn32.Flags=NTFS_FORCEEXT|NTFS_FILEMUSTEXIST|NTFS_EMPTYFILE;
				strcpy(ofn32.lpstrDefExt,"wav");
				sprintf(ofn32.lpstrTitle,"Pick WAV-file to assign...",i+1);
				strcpy(ofn32.lpstrFilter,"wav");
				if(DialogBox(hInst,(LPCTSTR)"NTFS",hWnd,(DLGPROC)NTFSDlgProc)==TRUE){
            	SendMessage(hStatusWnd,SB_SETTEXT,(WPARAM)0,(LPARAM)"Loading file...");
					UpdateWindow(hWnd);
					// write ini:
					if(strlen(ofn32.lpstrFile))
						sprintf(szBuf,"%s\\%s",ofn32.lpstrPath,ofn32.lpstrFile);
					else
						szBuf[0]=0;
					sprintf(szSmallBuf,"Wave%d",i+1);
					WritePrivateProfileString(INIC,szSmallBuf,szBuf,"IMMORTAL.INI");
					// unload memory:
					if(memState[i]){
						GlobalUnlock(memS[i]);
						GlobalFree(memS[i]);
                  memState[i]=0;
					}
					// reload new file (NTFS_FILEMUSTEXIST):
					if(!strlen(ofn32.lpstrFile)||access(szBuf,0)){
                  strcpy(bnames[i],"< empty >");
						WritePrivateProfileString(INIC,szSmallBuf,"","IMMORTAL.INI");
               }
               else{
						fp=fopen(szBuf,"rb");
						l=filelength(fileno(fp));
						memS[i]=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE,(DWORD)l);
						if(memS[i]==NULL){
							MessageBox(NULL,"Not enough memory available!","ERROR",MB_OK|MB_ICONSTOP);
							fclose(fp);
							return 0;
						}
						memSP[i]=GlobalLock(memS[i]);
						fread(memSP[i],l,1,fp);
						fclose(fp);
						fnsplit(szBuf,NULL,NULL,filename,NULL);
						filename[8]=0; // chop off if NTFS-name
						strlwr(filename);
						filename[0]=(char)toupper(filename[0]);
						strcpy(bnames[i],filename);
						memState[i]=1;
               }
					// update button-name:
   	       	sprintf(szTmpBuf,"F%d",i+1);
      	      hdc=GetDC(hStatusWnd);
         	   sprintf(szBuf,"");
					for(;;){
						GetTextExtentPoint32(hdc,szTmpBuf,strlen(szTmpBuf),&size1);
						GetTextExtentPoint32(hdc,bnames[i],strlen(bnames[i]),&size2);
         	      if(size1.cx>=size2.cx)
      	   	     	break;
	               // add space to both sides of Fn:
   	            szBuf[strlen(szBuf)+1]=0;
      	         szBuf[strlen(szBuf)]=' ';
         	      sprintf(szTmpBuf,"%sF%d%s",szBuf,i+1,szBuf);
	          	}
   	         ReleaseDC(hStatusWnd,hdc);
					sprintf(szBuf,"%s\n%s",szTmpBuf,bnames[i]);
					SendMessage(bt[i],WM_SETTEXT,0,(LPARAM)((LPCSTR)szBuf));
					// clear statuswindow:
   	        	SendMessage(hStatusWnd,SB_SETTEXT,(WPARAM)0,(LPARAM)"");
				}
			}
			return 0;
		case WM_KEYDOWN:
			switch(wParam){
				case VK_SPACE:
					sndPlaySound(NULL,playmode);
					break;
				case VK_F1:
					sndPlaySound(memSP[0],playmode);
					last=0;
					break;
				case VK_F2:
					sndPlaySound(memSP[1],playmode);
					last=1;
					break;
				case VK_F3:
					sndPlaySound(memSP[2],playmode);
					last=2;
					break;
				case VK_F4:
					sndPlaySound(memSP[3],playmode);
					last=3;
					break;
				case VK_F5:
					sndPlaySound(memSP[4],playmode);
					last=4;
					break;
				case VK_F6:
					sndPlaySound(memSP[5],playmode);
					last=5;
					break;
				case VK_F7:
					sndPlaySound(memSP[6],playmode);
					last=6;
					break;
				case VK_F8:
					sndPlaySound(memSP[7],playmode);
					last=7;
					break;
				case VK_F9:
					sndPlaySound(memSP[8],playmode);
					last=8;
					break;
            // F10 does not send a VK_F10, it's a syskey
				case VK_F11:
					sndPlaySound(memSP[10],playmode);
					last=10;
					break;
				case VK_F12:
					sndPlaySound(memSP[11],playmode);
					last=11;
					break;
			}
			return 0;
		case WM_SIZE: // this msg is broadcasted on windowbuild too!
			if(wParam!=SIZE_MINIMIZED){
         	// update/create statusbar:
            DestroyWindow(hStatusWnd);
         	hStatusWnd=CreateWindow(
			   	STATUSCLASSNAME,
			      "",
			      WS_CHILD|WS_VISIBLE,
			      0,0,0,0,
					hWnd,
            	NULL,
            	hInst,
            	NULL
            );
				GetClientRect(hWnd,&rect);
				GetClientRect(hStatusWnd,&srect);
            rect.bottom-=srect.bottom; // we need this for button-cords
            for(i=0;i<3;i++)
            	parts[i]=(srect.right/4)*(i+2);
				SendMessage(hStatusWnd,SB_SETPARTS,(WPARAM)3,(LPARAM)parts);
            SendMessage(hStatusWnd,SB_SETTEXT,(WPARAM)1,
            					loop?(LPARAM)"LOOP: ON":(LPARAM)"LOOP:OFF");
            SendMessage(hStatusWnd,SB_SETTEXT,(WPARAM)2,
            					sync?(LPARAM)"SYNC: ON":(LPARAM)"SYNC:OFF");
				for(i=0;i<12;i++){
					DestroyWindow(bt[i]);
					x=(i%4)*(rect.right/4);
					width=rect.right/4;
					height=rect.bottom/3;
					if(i<4)
						y=0;
					else if(i<8)
						y=rect.bottom/3;
					else
						y=(2*rect.bottom)/3;
             	sprintf(szTmpBuf,"F%d",i+1);
               hdc=GetDC(hStatusWnd);
               sprintf(szBuf,"");
					for(;;){
						GetTextExtentPoint32(hdc,szTmpBuf,strlen(szTmpBuf),&size1);
						GetTextExtentPoint32(hdc,bnames[i],strlen(bnames[i]),&size2);
                  if(size1.cx>=size2.cx)
                  	break;
                  // add space to both sides of Fn:
                  szBuf[strlen(szBuf)+1]=0;
                  szBuf[strlen(szBuf)]=' ';
                  sprintf(szTmpBuf,"%sF%d%s",szBuf,i+1,szBuf);
               }
               ReleaseDC(hStatusWnd,hdc);
					sprintf(szBuf,"%s\n%s",szTmpBuf,bnames[i]);
					bt[i]=CreateWindow(
						(LPSTR)"BUTTON",
						(LPSTR)szBuf,
                  notify?WS_CHILD|WS_VISIBLE|BS_MULTILINE|BS_VCENTER|BS_CENTER|BS_NOTIFY:
			                WS_CHILD|WS_VISIBLE|BS_MULTILINE|BS_VCENTER|BS_CENTER,
						x,
						y,
						width,
						height,
						hWnd,
						(HMENU)(WM_USER+i),	// message ID
						hInst,
						0
					);
				}
			}
			return 0;
		case WM_QUIT:
		case WM_DESTROY:
      	// Win95 needs next line (Win32 did not):
			wp.length=sizeof(WINDOWPLACEMENT);
			GetWindowPlacement(hWnd,&wp);
			if(wp.showCmd!=SW_MINIMIZE){ // save size and position
				sprintf(szBuf,"%ld",wp.rcNormalPosition.left);
				WritePrivateProfileString(INIC,"X",szBuf,"IMMORTAL.INI");
				sprintf(szBuf,"%ld",wp.rcNormalPosition.top);
				WritePrivateProfileString(INIC,"Y",szBuf,"IMMORTAL.INI");
				sprintf(szBuf,"%ld",wp.rcNormalPosition.right-wp.rcNormalPosition.left);
				WritePrivateProfileString(INIC,"W",szBuf,"IMMORTAL.INI");
				sprintf(szBuf,"%ld",wp.rcNormalPosition.bottom-wp.rcNormalPosition.top);
				WritePrivateProfileString(INIC,"H",szBuf,"IMMORTAL.INI");
				sprintf(szBuf,"%d",last);
				WritePrivateProfileString(INIC,"Last",szBuf,"IMMORTAL.INI");

			}
			// free memory:
			for(i=0;i<12;i++){
				if(memState[i]){
					GlobalUnlock(memS[i]);
					GlobalFree(memS[i]);
				}
			}
			PostQuitMessage(0);
			break;
		default:
			return(DefWindowProc(hWnd,message,wParam,lParam));
	}
	return 0L;
}


#pragma argsused
int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrev,LPSTR lpCmdLine,int nCmdShow){
	MSG msg;
   OSVERSIONINFO osVer;

   // check version:
	osVer.dwOSVersionInfoSize=sizeof(osVer);
	if(!GetVersionEx(&osVer))
		return(FALSE);
	if(osVer.dwPlatformId!=VER_PLATFORM_WIN32_WINDOWS){
		MessageBox(NULL,"Windows 95 required!","",MB_OK);
		return(FALSE);
	}

	if(!InitApplication(hInstance))
		return (FALSE);
	if(!InitInstance(hInstance,nCmdShow))
		return (FALSE);
	while(GetMessage(&msg,NULL,0,0)){
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return(msg.wParam);
}

